(function (win, doc, exports) {

    'use strict';

    /**
     * ボタンクラス
     * btnText ... ボタンに表示するテキスト
     */
    function Button(btnText) {
        this._super();
        this._btnText = btnText;
        this._init();
    }

    //Componentクラスを継承
    extend(Button, Component);

    //初期化処理
    Button.prototype._init = function () {
        var _el = this.getEl();
        _el.innerHTML = this._btnText;
        this.addClass('sample-button');
    };

    //クリックイベントに処理を追加
    Button.prototype.click = function (callback, context) {
        this.getEl().addEventListener('click', callback.bind(context || this), false);
    };

    /*! ------------------------------------------------------------------------
        内部で定義したクラスを外部から参照できるようにExport
    ---------------------------------------------------------------------------- */
    exports.Button = Button;

}(window, document, window));
