(function (win, doc, exports) {

    //'use strict';

    /**
     * クラス継承用関数
     * child  ... 派生クラスを指定
     * _super ... 基底クラスを指定
     */
    function extend(child, _super) {
        function ctor() { this.constructor = child; }
        ctor.prototype = _super.prototype;
        child.prototype = new ctor();
        child.prototype._superclass = _super;
        child.prototype._super = function () {
            this._prevctor = (this._prevctor) ? this._prevctor.prototype._superclass : _super;
            this._prevctor.apply(this, arguments);
        };
    }

    /*! ------------------------------------------------------------------------
        内部で定義したクラスを外部から参照できるようにExport
    ---------------------------------------------------------------------------- */
    exports.extend = extend;

}(window, document, window));
